<script lang="ts">
    import { createEventDispatcher, onMount } from 'svelte';
    import { EditorView, minimalSetup } from "codemirror";
    import { autocompletion } from '@codemirror/autocomplete';
    import type { CompletionContext, CompletionResult } from '@codemirror/autocomplete';
    import { keywordCompletionSource, MySQL, sql } from '@codemirror/lang-sql';
    import { highlightActiveLineGutter, lineNumbers, keymap } from '@codemirror/view';
    import type { KeyBinding } from '@codemirror/view';
    import { defaultHighlightStyle, syntaxHighlighting } from '@codemirror/language';
    import type { ServerModel } from '../app/domain/models/server.model';
    import type { QuerierModel } from '../app/domain/models/querier.model';
    import type { SqlResponse } from '../app/infrastructure/types/sql-response';
    import useCases from '../app/use-cases';
    import { MakeSortable, SortLink, SortHeader } from 'svelte-simple-table';
    import { CompletionHelper } from '../app/helpers/completion.helper';

    export let server: ServerModel;
    export let querier: QuerierModel;

    export let actions = {
        focusEditor: () => {
            focusEditor();
        }
    };

    let data: string;
    let domIFrame: HTMLIFrameElement;
    let domCodeEditor: HTMLDivElement;
    let editorView: EditorView;
    let filter: string;


    let columns: string[] = [];
    let rows: Record<string, string>[] = [];

    const dispatch = createEventDispatcher();


    onMount(() => {
        const codeKeymap: ReadonlyArray<KeyBinding> = [
            {
                key: 'Ctrl-Enter',
                run: (target: EditorView): boolean => {
                    execAll();
                    return true;
                }
            },
            {
                key: 'Ctrl-Shift-k',
                run: (target: EditorView): boolean => {
                    execSelection();
                    return true;
                }
            }
        ];

        editorView = new EditorView({
            doc: querier.sql,
            extensions: [
                minimalSetup,
                sql({dialect: MySQL, upperCaseKeywords: true}), autocompletion({override: [myCompletions, keywordCompletionSource(MySQL, true)]}),
                lineNumbers(),
                highlightActiveLineGutter(),
                syntaxHighlighting(defaultHighlightStyle, { fallback: true }),
                keymap.of(codeKeymap)
            ],
            parent: domCodeEditor
        });
        // editorView.
        focusEditor();
    });

    function focusEditor() {
        setTimeout(() => {
            editorView.focus();
        }, 200);
    }

    function myCompletions(context: CompletionContext): CompletionResult {
        const allSql = editorView.state.doc.toString();
        const aliases = CompletionHelper.getTablesWithAlias(allSql);

        let word = context.matchBefore(/\w*/);
        if (context.pos >= 1 && allSql.charAt(context.pos - 1) === '.') {
            const wordBeforeDot = allSql.substring(0, context.pos - 1).replace(/`/g, '').match(/(\w+)$/);
            if (wordBeforeDot) {
                const alias = aliases[wordBeforeDot[0].toLowerCase()];
                return {
                    from: word.from,
                    options: server.complete(alias).map(completion => ({
                        label: completion,
                        type: 'variable' // en noir
                    }))
                };
            }
        }
        if (word.from == word.to && !context.explicit)
            return null;
        return {
            from: word.from,
            options: server.getTablesCompletion().map(tableName => ({
                label: tableName,
                type: 'variable'
            }))
        };
    }

    async function execSql(sql: string) {
        const json = await useCases.dbQueryUc.execute(server, sql);
        columns = json.length > 0 ? Object.keys(json[0]) : [];
        rows = json;
    }

    async function execAll() {
        const allSql = editorView.state.doc.toString();
        querier.sql = allSql;
        dispatch('save');
        execSql(allSql);
    }

    async function execSelection() {
        const allSql = editorView.state.doc.toString();
        querier.sql = allSql;
        dispatch('save');
        const range = editorView.state.selection.main;
        const selectedSql = allSql.substring(range.from, range.to);
        execSql(selectedSql);
    }

    function sqlResponseToHtmlTable(json: SqlResponse): string {
        return JSON.stringify(json, null, 2);
    }

</script>

<div bind:this={domCodeEditor}></div>
<button class="button is-small" on:click={() => execAll()}>Exec <small>(Ctrl+Enter)</small></button>
<button class="button is-small" on:click={() => execSelection()}>Exec Selection <small>(Ctrl+Maj+K)</small></button>
<p>--</p>
<div>
    <input class="input" type="text" placeholder="Filter" bind:value={filter}>
</div>
<MakeSortable
        data={rows}
        let:table
        filter={filter}
        filterFields={columns}
        sortIconCss="fa fa-sort"
        sortIconAscCss="fa fa-sort-asc"
        sortIconDescCss="fa fa-sort-desc"
>
    Rows: { table.rows.length }<br />
    Filtered Rows: { table.sortedAndFilteredRows.length }<br />

    <div class="table-container">
        <table class="table is-bordered is-striped is-narrow is-hoverable ">
            <thead>
            <tr>
                {#each columns as column}
                    <SortHeader path={column}>{column}</SortHeader>
                {/each}
            </tr>
            </thead>
            <tbody>
            {#each table.pageRows as row}
                <tr>
                    {#each columns as column}
                        <td>{row[column]}</td>
                    {/each}
                </tr>
            {/each}
            </tbody>
        </table>
    </div>
    <div class="buttons has-addons">
        <button class="button" on:click={table.paging.onPrevious} disabled={table.paging.currentPage === 0}>Previous</button>
        {#each table.paging.buttons as btn (btn)}
            <button class="button" class:is-selected={btn.active} class:is-primary={btn.active} on:click={btn.onClick}>{btn.label}</button>
        {/each}
        <button class="button" on:click={table.paging.onNext} disabled={table.paging.currentPage >= table.paging.pageCount-1}>Next</button>
    </div>
</MakeSortable>


<iframe bind:this={domIFrame} width="100%" height="400"></iframe>
